package com.framsticks.framclipse.resource;

import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.resource.IDefaultResourceDescriptionStrategy;
import org.eclipse.xtext.resource.IResourceDescription;
import org.eclipse.xtext.resource.impl.DefaultResourceDescriptionManager;
import com.google.inject.Inject;
import com.google.inject.Provider;

public class FramScriptResourceDescriptionManager extends
		DefaultResourceDescriptionManager {

	@Inject
	private IDefaultResourceDescriptionStrategy strategy;

	private static final String CACHE_KEY = FramScriptResourceDescriptionManager.class.getName() + "#getResourceDescription";
	
	public IResourceDescription getResourceDescription(final Resource resource) {
		return getCache().get(CACHE_KEY, resource, new Provider<IResourceDescription>(){
			public IResourceDescription get() {
				return new FramScriptResourceDescription(resource, strategy);
			}});
	}

}